package cn.com.infosec.crypto.generators;

import cn.com.infosec.crypto.AsymmetricCipherKeyPair;
import cn.com.infosec.crypto.AsymmetricCipherKeyPairGenerator;
import cn.com.infosec.crypto.KeyGenerationParameters;
import cn.com.infosec.crypto.params.RSAKeyGenerationParameters;
import cn.com.infosec.crypto.params.RSAKeyParameters;
import cn.com.infosec.crypto.params.RSAPrivateCrtKeyParameters;
import java.math.BigInteger;

public class RSAKeyPairGenerator implements AsymmetricCipherKeyPairGenerator {
   private static final BigInteger ONE = BigInteger.valueOf(1L);
   private RSAKeyGenerationParameters param;

   public void init(KeyGenerationParameters param) {
      this.param = (RSAKeyGenerationParameters)param;
   }

   public AsymmetricCipherKeyPair generateKeyPair() {
      int var10001 = this.param.getStrength();
      int var1;
      int var2 = var10001 - (var1 = (var10001 + 1) / 2);
      int var3 = var10001 / 3;
      BigInteger var4 = this.param.getPublicExponent();

      BigInteger var5;
      BigInteger var6;
      BigInteger var10000;
      do {
         while(true) {
            var10000 = var5 = new BigInteger;
            var5.<init>(var1, 1, this.param.getRandom());
            if (var10000.mod(var4).equals(var6 = ONE)) {
               continue;
            }
            break;
         }
      } while(!var5.isProbablePrime(this.param.getCertainty()) || !var4.gcd(var5.subtract(var6)).equals(var6));

      while(true) {
         while(true) {
            BigInteger var10;
            var10000 = var10 = new BigInteger;
            var10.<init>(var2, 1, this.param.getRandom());
            if (var10000.subtract(var5).abs().bitLength() >= var3 && !var10.mod(var4).equals(var6 = ONE) && var10.isProbablePrime(this.param.getCertainty()) && var4.gcd(var10.subtract(var6)).equals(var6)) {
               BigInteger var7;
               if ((var7 = var5.multiply(var10)).bitLength() == this.param.getStrength()) {
                  BigInteger var9;
                  if (var5.compareTo(var10) < 0) {
                     var9 = var5;
                  } else {
                     var9 = var10;
                     var10 = var5;
                  }

                  BigInteger var11;
                  BigInteger var12;
                  BigInteger var10002 = var5 = var4.modInverse((var11 = var10.subtract(var6)).multiply(var12 = var9.subtract(var6)));
                  var11 = var5.remainder(var11);
                  var12 = var10002.remainder(var12);
                  var6 = var9.modInverse(var10);
                  RSAKeyParameters var13 = new RSAKeyParameters(false, var7, var4);
                  RSAPrivateCrtKeyParameters var8;
                  var8 = new RSAPrivateCrtKeyParameters.<init>(var7, var4, var5, var10, var9, var11, var12, var6);
                  return new AsymmetricCipherKeyPair(var13, var8);
               }

               var5 = var5.max(var10);
            }
         }
      }
   }
}
